<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "quality_area".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "QualityArea".
 *
 * Columns in table "quality_area" available as properties of the model,
 * followed by relations of table "quality_area" available as properties of the model.
 *
 * @property integer $id
 * @property string $name
 * @property integer $maximum_cost
 * @property integer $minimum_cost
 * @property string $quality_path_description
 * @property integer $provider_level_search
 *
 * @property ProviderTreatmentPerformed[] $providerTreatmentPerformeds
 * @property QualityPath[] $qualityPaths
 */
abstract class BaseQualityArea extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'quality_area';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'QualityArea|QualityAreas', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('name', 'required'),
            array('maximum_cost, minimum_cost, provider_level_search', 'numerical', 'integerOnly' => true),
            array('name', 'length', 'max' => 100),
            array('quality_path_description', 'length', 'max' => 255),
            array('maximum_cost, minimum_cost, quality_path_description, provider_level_search', 'default',
                'setOnEmpty' => true, 'value' => null),
            array('id, name, maximum_cost, minimum_cost, quality_path_description, provider_level_search',
                'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'providerTreatmentPerformeds' => array(self::HAS_MANY, 'ProviderTreatmentPerformed', 'quality_area_id'),
            'qualityPaths' => array(self::HAS_MANY, 'QualityPath', 'quality_area_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'maximum_cost' => Yii::t('app', 'Maximum Cost'),
            'minimum_cost' => Yii::t('app', 'Minimum Cost'),
            'quality_path_description' => Yii::t('app', 'Quality Path Description'),
            'provider_level_search' => Yii::t('app', 'Provider Level Search'),
            'providerTreatmentPerformeds' => null,
            'qualityPaths' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('maximum_cost', $this->maximum_cost);
        $criteria->compare('minimum_cost', $this->minimum_cost);
        $criteria->compare('quality_path_description', $this->quality_path_description, true);
        $criteria->compare('provider_level_search', $this->provider_level_search);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
